/*test create-node method*/
function nodeCreation returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.

   create x-document hDoc.
   create x-noderef hRoot.

   res = hDoc:create-node(hRoot,"root","eLEMENT") no-error.
   if not error-status:error and not error-status:get-number(1) eq 0 or not res then message "Unexpected create-node error code1: " error-status:get-number(1) " " error-status:get-message(1).

   err-num = 9171.
   res = false.
   res = hDoc:create-node(hRoot,"root","eLEMEN1T") no-error.

   if not error-status:error and not error-status:get-number(1) eq err-num or res
         then message "Unexpected create-node error code2: " error-status:get-number(1) " " error-status:get-message(1).

   err-num = -1.
   res = false.
   res = hDoc:create-node(hRoot,"root",c) no-error.

   if not error-status:error and not res and not error-status:get-number(1) eq err-num
         then message "Unexpected create-node error code3: " error-status:get-number(1) " " error-status:get-message(1).

   err-num = 9082.
   res = false.
   res = hDoc:create-node(hRoot,c,"ELEMENT") no-error.

   if not error-status:error and not error-status:get-number(1) eq err-num or res
         then message "Unexpected create-node error code4: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test get-document-element method*/
function getDocumentElement returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.

   create x-document hDoc.
   create x-noderef hRoot.
   hDoc:create-node(hRoot,"root","eLEMENT") no-error.

   /*just check that hRoot is valid */
   hRoot:subtype no-error.
   if not error-status:error and not error-status:get-number(1) eq 0
            then message "Unexpected error: " error-status:get-number(1) " " error-status:get-message(1).

   /*check here that hRoot has been changed and now doesn't contains old node*/
   res = hDoc:get-document-element(hRoot).
   hRoot:subtype no-error.
   if not error-status:error and error-status:get-number(1) eq 0 or not res
            then message "Unexpected error: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test encoding attribute*/
function getEncoding returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.

   create x-document hDoc.

   c = hDoc:encoding.
   if not c eq "" then "Unexpected error: encoding doesn't equals empty string".
   hDoc:encoding = "utf8".
   if not c eq "utf8" then "Unexpected error: encoding doesn't equals utf8".

   return 0.
end.

/*test schema-location attribute*/
function schemaLoc returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.

   create x-document hDoc.

   c = hDoc:schema-location.
   if not c eq ? then "Unexpected error: schema-location doesn't equals empty string".

   c = ?.
   hDoc:schema-location = c no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
            then message "Unexpected error schema-location: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:schema-location = "test test".
   if not hDoc:schema-location eq "test test" then "Unexpected error: schema-location".

   return 0.
end.

/*test schema-path attribute*/
function schemaPath returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.

   create x-document hDoc.

   c = hDoc:schema-path.
   if not c eq ? then "Unexpected error: schema-path doesn't equals empty string".

   c = ?.
   hDoc:schema-path = c no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
            then message "Unexpected error schema-path: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:schema-path = "test test".
   if not hDoc:schema-path eq "test test" then "Unexpected error: schema-path".

   return 0.
end.

/*test schema-path attribute*/
function getPublicId returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hNode1 as handle.
   def var res as logical init false.
   def var c as character.
   def var unk as character.

   create x-document hDoc.

   c = hDoc:public-id.
   if not c eq ? then "Unexpected error: public-id doesn't equals empty string".
   c = ?.
   hDoc:public-id = c no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
            then message "Unexpected error: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:public-id = "test test" no-error.
   if not error-status:error and not error-status:get-number(1) eq 4052
      then message "Unexpected error: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test get and set SuppressNamespaceProcessing attribute*/
function getSuppressNamespaceProcessing returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var res as logical init false.
   def var l as logical.
   create x-document hDoc.
   l = hDoc:suppress-namespace-processing.
   if l then "Unexpected error: SuppressNamespaceProcessing doesn't equals false".
   hDoc:suppress-namespace-processing = true.
   if not l then "Unexpected error: SuppressNamespaceProcessing doesn't equals true".
   hDoc:suppress-namespace-processing = ? no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
               then message "Unexpected error: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test deleteNode attribute X-NODEREF*/
function deleteNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:append-child(hRoot).
   if not hRoot:delete-node then "Unexpected error: delete-node".

   l = hRoot:delete-node no-error.

   if not error-status:error and not error-status:get-number(1) eq 9102 and l
                  then message "Unexpected error delete-node: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test deleteNode attribute X-NODEREF*/
function getParent returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hWork as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hDoc:append-child(hRoot).

   hChild:get-parent(hWork) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                        then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   create x-noderef hWork.

   hChild:get-parent(hWork).
   hWork:subtype no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
                     then message "Unexpected error get-parent: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:append-child(hChild).
   hChild:get-parent(hWork).

   hWork:subtype.

   if hWork:name <> hRoot:name then message "error get-parent".

   return 0.
end.


/*test node-value attribute X-NODEREF*/
function getSetNodeValue returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hChild:node-value=? no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).
   hChild:node-value="asd" no-error.

   if not hChild:node-value eq "asd" then "Unexpected error: node-value".

   hDoc:create-node(hChild,"ch","element").
   hChild:node-value="asd" no-error.

   if not error-status:error and not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).
   return 0.
end.

/*test clone-node attribute X-NODEREF*/
function cloneNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hCloneNode as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"child","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:clone-node(hCloneNode, ?) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                        then message "Unexpected error clone-node: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hCloneNode.
   l = hRoot:clone-node(hCloneNode, true) no-error.

   if hRoot:name <> hCloneNode:name or not l then message "error clone-node".

   return 0.
end.

/*test owner-document attribute X-NODEREF*/
function ownerDocument returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var res as logical init false.
   create x-document hDoc.
   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:append-child(hRoot).

   hDoc2 = hRoot:owner-document.

   if hDoc <> hDoc2 then message "error owner-document".
   hRoot:owner-document = hDoc no-error.

   if not error-status:error and not error-status:get-number(1) eq 4052
                        then message "Unexpected error owner-document: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test GET-ATTRIBUTE attribute X-NODEREF*/
function getAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).


   hRoot:get-attribute(?) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                           then message "Unexpected error get-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-attribute("test").
   hRoot:set-attribute("test", "data").
   c = hRoot:get-attribute("test").
   if c <> "data" then message "Unexpected error get-attribute".
   if hChild:get-attribute("test") <> "" then message "Unexpected error get-attribute".

   return 0.
end.

/*test owner-document attribute X-NODEREF*/
function setAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   c = ?.
   hRoot:set-attribute("a", c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                              then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:set-attribute(c, "a") no-error.
      if not error-status:error and not error-status:get-number(1) eq 4065
                                 then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).
   hRoot:set-attribute(c, c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                                 then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute("&", "asd") no-error.
      if not error-status:error and not error-status:get-number(1) eq 9082
                                 then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:set-attribute("test", "asd") no-error.
      if not error-status:error and not error-status:get-number(1) eq 9082
                                 then message "Unexpected error set-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute("test", "data").
   c = hRoot:get-attribute("test").
   if c <> "data" then message "Unexpected error set-attribute".

   return 0.
end.


/*test set-attribute-node attribute X-NODEREF*/
function setAttributeNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hAttr as handle.
   def var hChild2 as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hAttr.
   create x-noderef hChild2.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:create-node(hChild2,"ddd","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:set-attribute-node(hDoc) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                              then message "Unexpected error set-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:set-attribute-node(hAttr) no-error.

   if not error-status:error and not error-status:get-number(1) eq 9102
                                    then message "Unexpected error set-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).
   hDoc:create-node(hAttr,"ttt","attribute").

   hChild:set-attribute-node(hAttr) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
      then message "Unexpected error set-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   res = hRoot:set-attribute-node(hAttr).
   if not res then message "Unexpected error set-attribute-node".

   hChild2:set-attribute-node(hAttr) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
         then message "Unexpected error set-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test get-attribute-node attribute X-NODEREF*/
function getAttributeNode returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hAttr as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hAttr.
   create x-noderef hTemp.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:create-node(hAttr,"ttt","attribute").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:set-attribute-node(hAttr).
   c = ?.
   hRoot:get-attribute-node(hTemp, c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hChild:get-attribute-node(hTemp, "ttt") no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
      then message "Unexpected error get-attribute-node: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-attribute-node(hTemp, "ttt").

   if hAttr:name <> hTemp:name then message "get-attribute-node".

   return 0.
end.

/*test subtype attribute X-NODEREF*/
function getSubType returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hTemp:subtype no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
         then message "Unexpected error subtype: " error-status:get-number(1) " " error-status:get-message(1).

   if hRoot:subtype <> "ELEMENT" or hChild:subtype <> "TEXT" or hDoc:subtype <> "DOCUMENT" then message "subtype".

   hRoot:subtype = "asd" no-error.
   if not error-status:error and not error-status:get-number(1) eq 4052
            then message "Unexpected error subtype: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test num-children attribute X-NODEREF*/
function getNumChildren returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hRoot:num-children no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
         then message "Unexpected error num-children: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).

   if hRoot:num-children <> 2 or hDoc:num-children <> 1 then message "Unexpected error num-children".
   return 0.
end.

/*test child-num attribute X-NODEREF*/
function getChildNum returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hRoot.
   create x-noderef hChild.
   create x-noderef hTemp.

   hRoot:child-num no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
         then message "Unexpected error child-num: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hTemp,"hTemp","element").
   hDoc:create-node(hChild,"","text").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).


   if hRoot:child-num <> 1 or hTemp:child-num <> 2 or hDoc:child-num <> ? then message "Unexpected error child-num".
   return 0.
end.

/*test append-child attribute X-NODEREF*/
function appendChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:append-child(hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
            then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:append-child(hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
               then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").

   hDoc2:append-child(hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"root2","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hChild:append-child(hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
                  then message "Unexpected error append-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test get-child attribute X-NODEREF*/
function getChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   def var i as integer init 1.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.

   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hRoot:get-child(hTemp, 1) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hTemp.
   i = ?.
   hRoot:get-child(hTemp, i) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   hTemp:get-child(hTemp, 1) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:get-child(hTemp, 10) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
            then message "Unexpected error get-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test remove-child attribute X-NODEREF*/
function removeChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.

   hDoc:remove-child(hRoot) no-error.

   if not error-status:error and not error-status:get-number(1) eq 4065
            then message "Unexpected error remove-child: " error-status:get-number(1) " " error-status:get-message(1).

   hTemp:remove-child(hChild) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
               then message "Unexpected error remove-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"root2","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).

   hDoc2:remove-child(hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
                  then message "Unexpected error remove-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:remove-child(hRoot).
   hDoc:remove-child(hRoot) no-error.

   if not error-status:error and not error-status:get-number(1) eq 9082
                  then message "Unexpected error remove-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test name attribute X-NODEREF*/
function nameAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.

   hDoc:name.

   hRoot:name no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
               then message "Unexpected errorrname: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","text").
   hDoc:create-node(hTemp,"root2","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).


   if hChild:name <> "#text" then message "error takes name".

   hChild:name = "asd" no-error.

   if not error-status:error and not error-status:get-number(1) eq 4052
            then message "Unexpected error name: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test getAttributeNames attribute X-NODEREF*/
function getAttributeNames returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   hRoot:attribute-names no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
                  then message "Unexpected error getAttributeNames: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root","element").
   hDoc:append-child(hRoot).
   hRoot:set-attribute("atr1","data1").
   hRoot:set-attribute("atr2","data2").

   if not hRoot:attribute-names eq "atr1 atr2" then "Unexpected error: attribute-names".

   hRoot:attribute-names = "Asd" no-error.
   if not error-status:error and not error-status:get-number(1) eq 4052
                  then message "Unexpected error getAttributeNames: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.

/*test handleTest attribute X-NODEREF*/
/*
function handleTest returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var res as logical init false.
   def var l as logical.
   def var c as character.
   create x-document hDoc.
   create x-noderef hRoot.

   hRoot:handle = "asd".
   if not hRoot:handle eq hRoot then "Unexpected error: hRoot".
  return 0.
end.   */

/*test namespace-prefix attribute X-NODEREF*/
function namespacePrefixAndLocalNameAndURI returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.

   hDoc:namespace-prefix no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
                  then message "Unexpected error namespace-prefix: " error-status:get-number(1) " " error-status:get-message(1).


   hRoot:namespace-prefix no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
                  then message "Unexpected error namespace-prefix: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-uri no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
                  then message "Unexpected error namespace-prefix: " error-status:get-number(1) " " error-status:get-message(1).


   hDoc:create-node(hRoot,"root","element").

   if hRoot:namespace-uri <> "" then message "error hRoot:namespace-uri".
   if hRoot:local-name <> "" then message "error local-name".
   if hRoot:namespace-prefix <> "" then message "error namespace-prefix".

   hRoot:namespace-prefix = "tt" no-error.

   if not error-status:error and not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hRoot, "aa", "tt", "element").
   hRoot:namespace-prefix = "" no-error.
   if not error-status:error and not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                        then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-prefix = "ttt".
   if hRoot:namespace-prefix <> "ttt" or hRoot:name <> "ttt:tt" then message "error namespace-prefix".
   if hRoot:local-name <> "tt" then message "error local-name".
   if hRoot:namespace-uri <> "aa" then message "error hRoot:namespace-uri".

   hRoot:namespace-prefix = "&" no-error.
   if not error-status:error and not error-status:get-number(2) eq 9082 and not error-status:get-number(1) eq 3131
                     then message "Unexpected error node-value: " error-status:get-number(1) " " error-status:get-message(1).

   c = ?.
   hRoot:namespace-uri = c no-error.
   if not error-status:error and not error-status:get-number(1) eq 4083
                  then message "Unexpected error namespace-uri: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:namespace-uri = "asd" no-error.
   if not error-status:error and not error-status:get-number(1) eq 4052
                  then message "Unexpected error namespace-uri: " error-status:get-number(1) " " error-status:get-message(1).
   return 0.
end.


/*test insert-before attribute X-NODEREF*/
function insertBefore returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.


   hDoc:insert-before(hRoot, hChild) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
              then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:insert-before(hChild, hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
              then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"temp","element").
   hDoc:append-child(hRoot).
   hRoot:insert-before(hChild, hTemp2).
   if hRoot:num-children <> 1 then message "Unexpected error insert-before".
   hRoot:remove-child(hChild).
   create x-noderef hTemp2.

   hRoot:insert-before(hChild, hTemp2) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
              then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:insert-before(hChild, hChild) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
              then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:append-child(hTemp).
   hDoc:create-node(hTemp2,"temp","element").
   hTemp:append-child(hTemp2).

   hRoot:insert-before(hChild, hTemp2) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
              then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).
   hDoc2:create-node(hTemp2,"temp","element").
   hRoot:insert-before(hTemp2, hTemp) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
                 then message "Unexpected error insert-before: " error-status:get-number(1) " " error-status:get-message(1).
   return 0.
end.




/*test normalize attribute X-NODEREF TODO sub-types*/
function normalize returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hRoot.

   hRoot:normalize() no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
               then message "Unexpected error normalize: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hChild,"root1","text").
   hDoc:create-node(hTemp,"root1","text").
   hChild:node-value = "node1".
   hTemp:node-value = "node2".
   hChild:normalize() no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
      then message "Unexpected error normalize: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hRoot,"root1","element").
   hDoc:append-child(hRoot).
   hRoot:append-child(hChild).
   hRoot:append-child(hTemp).
   hRoot:normalize().
   if hRoot:num-children <> 1 then message "error normalize".
   hRoot:get-child(hTemp, 1).
   if hTemp:node-value <> "node1node2" then message "error normalize".

   return 0.
end.

/*test replace-child attribute X-NODEREF*/
function replaceChild returns int (err-num as int):
   def var hDoc as handle.
   def var hDoc2 as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.
   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-document hDoc2.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.

   hDoc:replace-child(hRoot, hChild) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
                 then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:replace-child(hChild, hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   create x-noderef hRoot.
   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild,"root1","element").
   hDoc:create-node(hTemp,"temp","element").

   hDoc:append-child(hRoot).


   hDoc:replace-child(hRoot, hChild) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:replace-child(hChild, hRoot).

   hDoc:get-child(hTemp2, 1).
   if hTemp2:name <> hChild:name then message "Unexpected error replace-child".
   hDoc:replace-child(hRoot, hChild).
   hDoc:get-child(hTemp2, 1).
   if hTemp2:name <> hRoot:name then message "Unexpected error replace-child".

   hDoc2:create-node(hTemp,"temp","element").
   hDoc:replace-child(hTemp, hRoot) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node(hTemp,"temp","element").
   hRoot:append-child(hChild).
   hChild:append-child(hTemp).

   hChild:replace-child(hRoot, hTemp) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
              then message "Unexpected error replace-child: " error-status:get-number(1) " " error-status:get-message(1).

   return 0.
end.


/*test node-value-to-longchar and longchar-to-node-value attribute X-NODEREF*/
function longCharNodeValue returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var lc1 as longchar no-undo.
   def var lc2 as longchar no-undo.
   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.
   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild, "a", "attribute").
   hDoc:append-child(hRoot).
   hRoot:set-attribute-node(hChild).

   do i=1 to 10000:
      lc1 = lc1 + string(i).
   end.

   hChild:longchar-to-node-value(lc1).

   hChild:node-value-to-longchar(lc2).

   if lc1 <> lc2 then message "Unexpected error node-value-to-longchar and longchar-to-node-value".

   lc1 = "&^@!#$%~027".

   hChild:longchar-to-node-value(lc1).

   return 0.
end.

/*test memptr-to-node-value and node-value-to-memptr attribute X-NODEREF*/
function memptrNodeValue returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var m1 as memptr no-undo.
   def var m2 as memptr no-undo.
   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.
   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild, "a", "attribute").
   hDoc:append-child(hRoot).
   hRoot:set-attribute-node(hChild).

   set-size(m1) = 10001.
   set-size(m2) = 101.
   do i=1 to 10000:
      put-byte(m1, i) = i.
   end.

   hChild:memptr-to-node-value(m1).

   hChild:node-value-to-memptr(m2).

   if m1 <> m2 then message "Unexpected error memptr-to-node-value and node-value-to-memptr".

   return 0.
end.

/*test remove-attribute X-NODEREF*/
function removeAttribute returns int (err-num as int):
   def var hDoc as handle.
   def var hRoot as handle.
   def var hChild as handle.
   def var hTemp as handle.
   def var hTemp2 as handle.

   def var i  as int no-undo.

   def var res as logical init false.
   def var c as character init false.
   create x-document hDoc.
   create x-noderef hChild.
   create x-noderef hTemp.
   create x-noderef hTemp2.
   create x-noderef hRoot.

   hDoc:create-node(hRoot,"root","element").
   hDoc:create-node(hChild, "a", "attribute").
   hDoc:create-node(hTemp, ?, "text").
   hDoc:append-child(hRoot).
   hRoot:set-attribute-node(hChild).
   hChild:node-value="test".

   c = ?.
   hRoot:remove-attribute(c, c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 4065
      then message "Unexpected error remove-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hTemp2:remove-attribute("a", c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9102
      then message "Unexpected error remove-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hRoot:remove-attribute("aa", c).
   if hRoot:get-attribute("a") <> "test" then message "Unexpected error remove-attribute".
   hRoot:remove-attribute("a", c).
   if hRoot:get-attribute("a") <> "" then message "Unexpected error remove-attribute".

   hTemp:remove-attribute("a", c) no-error.
   if not error-status:error and not error-status:get-number(1) eq 9082
         then message "Unexpected error remove-attribute: " error-status:get-number(1) " " error-status:get-message(1).

   hDoc:create-node-namespace(hTemp, "aaa", "ttt:el", "element").
   hDoc:create-node-namespace(hTemp2, "aaa", "ttt:at", "attribute").
   hTemp2:node-value="test".
   hTemp:set-attribute-node(hTemp2).

   hTemp:remove-attribute("ttt:at", "aaa") no-error.
   if hRoot:get-attribute("ttt:at") <> "" then message "Unexpected error remove-attribute".

   return 0.
end.

removeAttribute(-1).

/*memptrNodeValue(-1).*/
longCharNodeValue(-1).
replaceChild(-1).
normalize(-1).
insertBefore(-1).
namespacePrefixAndLocalNameAndURI(-1).
/*handleTest(-1).*/
getAttributeNames(-1).
nameAttribute(-1).
removeChild(-1).
getChild(-1).
appendChild(-1).
getChildNum(-1).
getNumChildren(-1).
getSubType(-1).
getAttributeNode(-1).
setAttributeNode(-1).
setAttribute(-1).
getAttribute(-1).
ownerDocument(-1).
cloneNode(-1).
getSetNodeValue(-1).
getParent(-1).
deleteNode(-1).
getAttributeNames(-1).
getSuppressNamespaceProcessing(-1).
getPublicId(-1).

nodeCreation(-1).
getDocumentElement(-1).
getEncoding(123).
schemaLoc(-1).
schemaPath(-1).
